Option Strict Off
Imports System
Imports NXOpen
Imports NXOpen.UF
Imports NXOpen.Assemblies

Module Intersect1
    Sub Main()
        Dim theSession As Session = Session.GetSession()
        Dim workPart As Part = theSession.Parts.Work
        Dim lw As ListingWindow = theSession.ListingWindow
        Dim ufs As UFSession = UFSession.GetUFSession()
        lw.Open()
        Dim myVectors(-1) As TaggedObject
        If SelectVectors("Select Vectors", myVectors) = Selection.Response.Cancel Then
            Return
        End If
        Dim myFaces(-1) As TaggedObject
        If SelectFaces("Select Faces", myFaces) = Selection.Response.Cancel Then
            Return
        End If
        Dim mybody As Body = Nothing
        Dim mystartpoint(2) As Double
        Dim myCenterPoint(2) as Double
        Dim myDistToIntersect(2) as Double
        Dim myendpoint(2) as Double
        Dim myintersectpoint(2) As Double
        Dim myfaceparms(1) As Double
        Dim intersectdata1 As NXOpen.UF.UFCurve.IntersectInfo = Nothing
        Dim intersectfound1 As Integer = Nothing
'        Dim intersectdataCheck As NXOpen.UF.UFCurve.IntersectInfo = Nothing
'        Dim intersectfoundCheck As Integer = Nothing
        Dim myMaterial as String = "unset"
        Dim intCount as Integer = 0
        For Each tempVector As Line In myVectors
            mystartpoint(0) =  FormatNumber(tempVector.StartPoint.X,6,,,TriState.True)
            mystartpoint(1) = FormatNumber(tempVector.StartPoint.Y,6,,,TriState.True)
            mystartpoint(2) = FormatNumber(tempVector.StartPoint.Z,6,,,TriState.True)
            myendpoint(0) = FormatNumber(tempVector.EndPoint.X,6,,,TriState.True)
            myendpoint(1) = FormatNumber(tempVector.EndPoint.Y,6,,,TriState.True)
            myendpoint(2) = FormatNumber(tempVector.EndPoint.Z,6,,,TriState.True)
            For Each tempFace As Face In myFaces
                ufs.Curve.Intersect(tempVector.Tag, tempFace.Tag, mystartpoint, intersectdata1)
                If intersectdata1.type_of_intersection = 0 Then
                    ' no intersection found
                ElseIf intersectdata1.type_of_intersection = 1 Then
                    ' 3D intersection found
                ElseIf intersectdata1.type_of_intersection = 2 Then
                    ' 2D intersection found
                End If
                If intersectdata1.type_of_intersection = 1 Then
                     if intCount = 0 then
                         lw.WriteLine(ControlChars.Quote & "Center Point (X1, Y1, Z1):" & ControlChars.Quote)
                         myCenterPoint(0) = mystartpoint(0)
                         myCenterPoint(1) = mystartpoint(1)
                         myCenterPoint(2) = mystartpoint(2)
                         lw.WriteLine(mystartpoint(0).ToString & "," & _
                                      mystartpoint(1).ToString & "," & _
                                      mystartpoint(2).ToString)
                         lw.WriteLine("Vector,X2,Y2,Z2,Face,Component,Material,IntX,IntY,IntZ,Dist")
                         intCount = intCount + 1
                     end if
                    myintersectpoint(0) = FormatNumber(intersectdata1.curve_point(0),6,,,TriState.True)
                    myintersectpoint(1) = FormatNumber(intersectdata1.curve_point(1),6,,,TriState.True)
                    myintersectpoint(2) = FormatNumber(intersectdata1.curve_point(2),6,,,TriState.True)
                    myDistToIntersect(0) = FormatNumber(((myintersectpoint(0)-myCenterPoint(0))^2+(myintersectpoint(1)-myCenterPoint(1))^2+(myintersectpoint(2)-myCenterPoint(2))^2)^.5,6,,,TriState.True)
                    myfaceparms(0) = intersectdata1.entity_parms(0)
                    myfaceparms(1) = intersectdata1.entity_parms(1)
                End If
                mybody = tempFace.GetBody
                If intersectdata1.type_of_intersection = 0 Then
        '                   lw.WriteLine("No intersection found")
                ElseIf intersectdata1.type_of_intersection = 1 Then
                     myMaterial=myBody.GetStringAttribute("MATERIAL")
'                     ufs.Curve.Intersect(tempVector.Tag, mybody.Tag, mystartpoint, intersectdataCheck)
'                     if intersectdata1.type_of_intersection = 0 Then
'                         lw.WriteLine("Note: Curve Intersects Face but not body")
'                     end if
                     lw.WriteLine(tempVector.Name & "," & _
                                     myendpoint(0).ToString & "," & _
                                     myendpoint(1).ToString & "," & _
                                     myendpoint(2).ToString & "," & _
                                     tempface.ToString & "," & _
                                     mybody.OwningComponent.Name & "," & _
                                     ControlChars.Quote & myMaterial & ControlChars.Quote & "," & _
                                     myintersectpoint(0).ToString & "," & _
                                     myintersectpoint(1).ToString & "," & _
                                     myintersectpoint(2) & "," & _
                                     myDistToIntersect(0).ToString & vbCrLf)
                End If
            Next
        Next
    End Sub

    Function SelectVectors(ByVal prompt As String, ByRef selObj() As TaggedObject) As Selection.Response

        Dim theUI As UI = UI.GetUI
        Dim title As String = "Select Vectors"
        Dim includeFeatures As Boolean = False
        Dim keepHighlighted As Boolean = False
        Dim selAction As Selection.SelectionAction = Selection.SelectionAction.ClearAndEnableSpecific
        Dim scope As Selection.SelectionScope = Selection.SelectionScope.AnyInAssembly
        Dim selectionMask_array(0) As Selection.MaskTriple

        With selectionMask_array(0)
            .Type = UFConstants.UF_line_type
            .Subtype = 0
        End With

        Dim resp As Selection.Response = theUI.SelectionManager.SelectTaggedObjects(prompt, _
         title, scope, selAction, _
         includeFeatures, keepHighlighted, selectionMask_array, _
         selObj)
        If resp = Selection.Response.Ok Then
            Return Selection.Response.Ok
        Else
            Return Selection.Response.Cancel
        End If

    End Function

    Function SelectFaces(ByVal prompt As String, ByRef selObj() As TaggedObject) As Selection.Response

        Dim theUI As UI = UI.GetUI
        Dim title As String = "Select Faces"
        Dim includeFeatures As Boolean = False
        Dim keepHighlighted As Boolean = False
        Dim selAction As Selection.SelectionAction = Selection.SelectionAction.ClearAndEnableSpecific
        Dim scope As Selection.SelectionScope = Selection.SelectionScope.AnyInAssembly
        Dim selectionMask_array(0) As Selection.MaskTriple
        With selectionMask_array(0)
            .Type = UFConstants.UF_face_type
            .Subtype = 0
        End With
        Dim resp As Selection.Response = theUI.SelectionManager.SelectTaggedObjects(prompt, _
         title, scope, selAction, _
         includeFeatures, keepHighlighted, selectionMask_array, _
         selObj)
        If resp = Selection.Response.Ok Then
            Return Selection.Response.Ok
        Else
            Return Selection.Response.Cancel
        End If
    End Function

    Public Function GetUnloadOption(ByVal dummy As String) As Integer

        'Unloads the image when the NX session terminates
        GetUnloadOption = NXOpen.Session.LibraryUnloadOption.AtTermination

    End Function

End Module 